#!/bin/sh
# $1 - IP switch'a , $2 - vlan, $3 - downlink-port
# in function vlantosw $3 - uplink $4 - downlink port
# prokidvlan poluchaet: MAC switch'a k kotoromu podkluchaut novii switch
# vlan kotorii nujno prokinut', downlink_port - port, kuda vkluchaut novii switch
# prokidvlan uses vlantosw to download config-update to switch
# vlantosw uses Expect to connect to switch

rootmac="0xccb25518b400";
loopcheck=0;
dotfile="mapdotodin.gv2.main"

mac2ip()
{
 b=`grep "^\"$1\" \[ " $dotfile`
 z=`echo $b | awk ' {a=match($0,/[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+/ ); b=substr($0,a,RLENGTH); print b;}'`
 echo "$z"
}



 # vlantosw() logging changes to file and writing changes to switch

vlantosw()
{
 swip=`mac2ip $1`
 echo "writetosw $swip vlan $2 uplink $3 downlink $4" >> vlan2sw."$5"
}



 # Prokidvlan() gets MAC of current switch, vlan, downlink port
 # Then finding uplink port of current switch, MAC of upper switch, downlink port of upper switch
 # then calling herself with new parameters of upper switch and additionally calling vlantosw to 
 # upload configuration to current switch and logging changes to file

prokidvlan()
{
 currentSwMac="$1"
 tmpmac=" \"${currentSwMac}"
 vlan="$2"
 port_downlink="$3"
        uplinktosw=`grep "${tmpmac}" $dotfile`
 mac_sw_uplink=`echo $uplinktosw | awk '{a=substr($0,2,14);print a;}'`
 port_uplink=`echo $uplinktosw | awk -f awk_sc3_find_uplink `
 port_downlink_new=`echo $uplinktosw | awk -f awk_sc3_find_downlink `
 vlantosw $currentSwMac $vlan  $port_uplink $port_downlink $4


 if [ $mac_sw_uplink = $rootmac ]; then  exit 0 ; fi

 loopcheck=$(($loopcheck + 1))
 if [ $loopcheck -eq 10 ]; then echo "ALARM!!! MAY BE LOOP!!"; exit 0; fi


 prokidvlan $mac_sw_uplink $vlan $port_downlink_new $4
}

 # Perevodim IP to MAC-address and calling prokidvlan()

 tmpstr=`grep ${1} $dotfile`
 macSW=`echo $tmpstr | awk '{a=substr($0,2,14);print a;}'`
 prokidvlan $macSW $2 $3 $4


