#!/bin/sh
rootmac="0xccb25518b400"
dotfile="mapdotodin.gv2"

recurce()
{


# Check that there are devices, connected to device with mac $1

grep $1 "$dotfile" > /dev/null

if [ $? -eq 1 ]; 
 then
  echo "mac=$1 result of grep = 1, returning 0"
 return 0; 
fi

echo > "${dotfile}.main"
grep -v "\-\-" "$dotfile" | grep -v "\}" >>  "${dotfile}.main"


 # Looking for all devices, connected to current device($1). 
 # When find - setting directing, then deleting string from source_file($dotfile)

grep "$1" "$dotfile" | grep "\-\-" | while read line
  do

    a=`echo "$line" | awk -f awk_prog2 -v rootmac="$1"`
    
    # In $a - contain resulting string with right direstion of arrow ->
    echo "$a";
    echo "$a" >> tmpfilemy


    # Here we finding right direction of arrow One more time and as result - deleting string $a from source file

    oldmac2=`echo $line | awk '{ a=substr($3,2,14);  print a ;}'`
    newmac2=`echo $a | awk '{ a=substr($3,2,14);  print a ;}'`
    newmac1=`echo $a | awk '{ a=substr($1,2,14);  print a ;}'`
    
    
     if [ "$oldmac2" = "$newmac2" ]
      then
       sed -i "/\"$newmac1\" -- \"$newmac2\"/ d" ./$dotfile    
      else
       sed -i "/\"$newmac2\" -- \"$newmac1\"/ d" ./$dotfile    
      fi
    recurce $newmac2;
  done 
}

recurce $rootmac;
cat tmpfilemy >> "${dotfile}.main"
echo -e "\n}" >> "${dotfile}.main"
sed -i 's/graph/digraph/g' mapdotodin.gv2.main
